var Evika_1 = new Evika("Evika_amati","Evika page","Evika FileSystem");
var DubleClickTimeout = 700;
var DeviceOnlineTimeout = 5000;    //Таймаут перехода в Offline
var DubleClickFirstClick = false;
var ParseFlag = false;

function Evika(DeviceName,Page,FSPage)
{
   var AutoRequestPeriod = 3000;
   
   var DEVICE = IR.GetDevice(DeviceName);
   var Amati_Online = false;
   var VolumeLevel = IR.GetVariable("Drivers."+DeviceName+".Amati_Volume level");
   var HoursTotal, MinutesTotal, SecondsTotal, TimeTotal;
   var TrackTimeTotal = "";
   var HoursPlayed, MinutesPlayed, SecondsPlayed, TimeElapsed;
   var TrackTimeElapsed = "";
   var TrackTimeProgress;   
   var TrackTimeSeek;
   var SongID, NextSongID;
   var tokenPL1 = tokenPL2 = 0;
   var PlaylistLength;
   var ListPlaylistLength;
   var PlaylistArray = [];
   var FilesystemLength;
   var FilesystemArray = [];
   var ListPlaylistArray = [];
   var FilesystemCurrentFolder = [];
   var DevOnlineSetTimeoutID;
   
   FilesystemCurrentFolder[0] = '';
   
   //Инициализация переменных
   IR.SetVariable("Drivers."+DeviceName+".Amati_Volume",0);
   IR.SetVariable("Drivers."+DeviceName+".Amati_State",0);
   IR.SetVariable("Drivers."+DeviceName+".Amati_Track time elapsed","");
   IR.SetVariable("Drivers."+DeviceName+".Amati_Track time total","");
   IR.SetVariable("Drivers."+DeviceName+".Amati_Track time progress",0);
   IR.SetVariable("Drivers."+DeviceName+".Amati_Track genre","");
   IR.SetVariable("Drivers."+DeviceName+".Amati_Track album","");
   IR.SetVariable("Drivers."+DeviceName+".Amati_Track album artist","");
   IR.SetVariable("Drivers."+DeviceName+".Amati_Track file","");
   IR.SetVariable("Drivers."+DeviceName+".Amati_Track title","");
   IR.SetVariable("Drivers."+DeviceName+".Amati_Playlist length",0);
   IR.SetVariable("Drivers."+DeviceName+".Amati_Next song ID",0);
   IR.SetVariable("Drivers."+DeviceName+".Amati_Random",0);
   IR.SetVariable("Drivers."+DeviceName+".Amati_Current song ID",0);
   IR.SetVariable("Drivers."+DeviceName+".Amati_Mute",0);
   IR.SetVariable("Drivers."+DeviceName+".Amati_Filesystem length",0);
   
   
   //-------------------------------------------------------
   // Device Online
   //-------------------------------------------------------     
   IR.AddListener(IR.EVENT_ONLINE, DEVICE, function(text)
    { 
      IR.SetVariable("Drivers."+DeviceName+".Amati_Online", true);
      Amati_Online = true;
      IR.ClearInterval(DevOnlineSetTimeoutID);
      DevOnlineSetTimeoutID = IR.SetTimeout(DeviceOnlineTimeout, function() { 
                  IR.SetVariable("Drivers."+DeviceName+".Amati_Online", false)
                  Amati_Online = false
                  });
     });             

   //Инициализация списка песен
   //IR.GetItem(Page).CreateItem(IR.ITEM_LISTBOX,"List 1", 259, 300, 370, 400);             
   //var List_1 = IR.GetItem(Page).GetItem("List 1");
   var List_1 = IR.GetItem(Page).GetItem("PlayList Item");
   List_1.Direction = 0; //Вертикально
   List_1.Template = "Evika Playlist Template";   // Прикрепляем шаблон к созданному листу
   
   //IR.GetItem(Page).CreateItem(IR.ITEM_LISTBOX,"List 2", 645, 300, 370, 400);             
   //var List_3 = IR.GetItem(Page).GetItem("List 2");
   var List_3 = IR.GetItem(Page).GetItem("ListPlayList Item");
   List_3.Direction = 0; //Вертикально
   List_3.Template = "Evika List of Filelists Template";   // Прикрепляем шаблон к созданному листу

   IR.GetItem(FSPage).CreateItem(IR.ITEM_LISTBOX,"List 1", 10, 84, 370, 400);             
   var List_2 = IR.GetItem(FSPage).GetItem("List 1");
   List_2.Direction = 0; //Вертикально
   List_2.Template = "Evika Filelist Template";   // Прикрепляем шаблон к созданному листу
   
   
   //Запрос обратной связи
   IR.SetInterval(AutoRequestPeriod,AutoRequest);
   IR.SetInterval(3*AutoRequestPeriod,AutoRequestPlaylist);
   
   //Функция запроса статуса
   function AutoRequest() //Запрос данных текущей песни
   {
      DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=status&param=null'])
   }
     
   function AutoRequestPlaylist() //Запрос данных текущего плей листа
   {
      if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=playlistinfo&param=null']);
      AutoRequestListPlaylist();
   } 

   function AutoRequestListPlaylist() //Запрос списка плей-листов
   {
      if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=listplaylists&param=null']);
   } 

   function AutoRequestFTP()  //Запрос данных состава файловой системы на ftp
   {
      if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=lsinfo&param="'+ FilesystemCurrentFolder[FilesystemCurrentFolder.length-1] + '"']);
      //IR.Log("request=cmd&cmd=lsinfo&param=\"ftp-asus\ = ",'request=cmd&cmd=lsinfo&param=\"ftp-asus\"')
      //IR.SetInterval(1000,DrawFS);
   }

   function TimeConvert(seconds)
   {
      var hours = Math.floor(seconds / 3600);
      var minutes = Math.floor((seconds - hours*3600) / 60);
      var seconds2 = seconds - hours*3600 - minutes*60;
            if(minutes < 10)
               minutes = "0" + minutes;
            if(seconds2 < 10)
               seconds2 = "0" + seconds2;
      var time = hours + ":" + minutes + ":" + seconds2;
      return time;
   }

//=======================================================
//======= Формирование списков песен и работа с ними ======
//=======================================================         
   function CheckPT()  //При изменении длины плейлиста формируем новый список элементов и выводим его 
   {
      tokenPL1 = tokenPL2; //Запоминаем старое значение
      //IR.Log("tokenPL1 = " + tokenPL1);
      tokenPL2 = PlaylistLength;  //Записываем новое значение
      //IR.Log("tokenPL2 = " + tokenPL2);
      if(tokenPL1 != tokenPL2)
      {
         List_1.Clear();
         for(i=0;i<PlaylistLength;i++)
         {
            // Массив [[АРТИСТ][НАЗВАНИЕ ПЕСНИ][АЛЬБОМ][ДЛИТЕЛЬНОСТЬ ПЕСНИ][ПОЗИЦИЯ В СПИСКЕ][ID]]
            List_1.CreateItem(PlaylistArray[6*i+5], 2, {Text: PlaylistArray[6*i+1]});  //Название песни  
            List_1.CreateItem(PlaylistArray[6*i+5], 1, {Text: PlaylistArray[6*i]});    //Артист
            List_1.CreateItem(PlaylistArray[6*i+5], 5, {Text: TimeConvert(PlaylistArray[6*i+3])});    //Длительность
            List_1.CreateItem(PlaylistArray[6*i+5], 6, {Text: "P:" + PlaylistArray[6*i+4] + " ID:" + PlaylistArray[6*i+5]}); //Позиция в плейлисте и Идентификатор в файловой системе
         }
      }   
   }
   
   function DrawFS()  //При изменении длины плейлиста формируем новый список элементов и выводим его 
   {
      List_2.Clear();
      for(i=0;i<FilesystemLength;i++)
      {
         //              0               1                 2           3     4 
         // Массив [[ИМЯ ФАЙЛА][ДЛИТЕЛЬНОСТЬ ПЕСНИ][ПОЗИЦИЯ В СПИСКЕ][ID][Folder]]
            List_2.CreateItem(i, 2, {Text: FilesystemArray[6*i]});  //Название песни  
            if (FilesystemArray[6*i+4] != true) List_2.CreateItem(i, 5, {Text: TimeConvert(FilesystemArray[6*i+1])});    //Длительность
      }
   }
   
   function DrawLPL()  //При изменении длины плейлиста формируем новый список элементов и выводим его 
   {
      List_3.Clear();
      for(i=0;i<ListPlaylistLength;i++)
      {
          List_3.CreateItem(i, 2, {Text: ListPlaylistArray[2*i]});  //Название песни  
          List_3.CreateItem(i, 1, {Text: "Last Modifed: " + ListPlaylistArray[2*i+1]});    //Дата изменения
      }
   }
   
   IR.AddListener(IR.EVENT_START,0,function()
   {
   DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=status&param=null']);
   DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=playlistinfo&param=null'])
   DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=listplaylists&param=null'])
   });   
   
   //Запуск песни из плейлиста
   IR.AddListener(IR.EVENT_ITEM_SELECT, List_1, function(Item, Subitem)
   {
      IR.Log("Item = " + Item + "; Subitem = " + Subitem);
      if(Subitem == 3)        //Кнопка Play
         if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=action&param={"action":"play","type":"current","arg":',Item.toString(),'}']);  
      if(Subitem == 4)    {    //Кнопка Delete song
         if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=action&param={"action":"remove","type":"current","arg":',Item.toString(),'}']);
         AutoRequestPlaylist();
         };   
   });

   //Запуск песни из файловой системы
   IR.AddListener(IR.EVENT_ITEM_SELECT, List_2, function(Item, Subitem)
   {
      IR.Log("List_2: Item = " + Item + "; Subitem = " + Subitem);
      if (Subitem == 2)  {      //Поле песни   {"action":"play","type":"filesystem","arg":"ftp-asus/01 11 (2008)"}
         if (DubleClickFirstClick == false) {
            DubleClickFirstClick = true;
            IR.SetTimeout(DubleClickTimeout, function() {DubleClickFirstClick = false })
            }
            else {
            if (FilesystemArray[6*Item+4] == true) {
               //FolderIndex = FolderIndex + 1;
               FilesystemCurrentFolder[FilesystemCurrentFolder.length] = FilesystemArray[6*Item];
               AutoRequestFTP(); 
               }
               else DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=action&param={"action":"play","type":"filesystem","arg":"' + FilesystemArray[6*Item] + '"}']);    
            };
         };  
      if (Subitem == 3)        //Кнопка Play   {"action":"play","type":"filesystem","arg":"ftp-asus/01 11 (2008)"}
         if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=action&param={"action":"play","type":"filesystem","arg":"' + FilesystemArray[6*Item] + '"}']);  
      if (Subitem == 4)    {    //Кнопка Add song
         if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=action&param={"action":"add","type":"filesystem","arg":"' + FilesystemArray[6*Item] + '"}']);
         AutoRequestPlaylist();
         };   
   });

   //Запуск/удаление в списке плейлистов
   IR.AddListener(IR.EVENT_ITEM_SELECT, List_3, function(Item, Subitem)
   {
      IR.Log("List_2: Item = " + Item + "; Subitem = " + Subitem);
      if (Subitem == 3)  {      //Кнопка Play
         if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=clear&param="null"']);
         PlaylistArray.length = 0;
         IR.SetTimeout(500, function() {
            if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=action&param={"action":"play","type":"playlist","arg":"'+ ListPlaylistArray[2*Item] + '"}']);
            AutoRequestPlaylist() });
         };
      if (Subitem == 4)  {      //Кнопка Delete
         if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=action&param={"action":"remove","type":"playlist","arg":"'+ ListPlaylistArray[2*Item] + '"}']);
         AutoRequestPlaylist() };
      
   });

   //Обработка внешней ссылки
   IR.AddListener(IR.EVENT_ITEM_PRESS, IR.GetItem("Evika Add Station").GetItem("Item 3"), function()
   {
      var name = IR.GetItem("Evika Add Station").GetItem("Item 1").Text;
      var link = IR.GetItem("Evika Add Station").GetItem("Item 2").Text;
      if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=radio-add&param=["',name,'","',link,'"]']);
   });
      
//==================================================================================
//==================================================================================
//==================================================================================
//==================================================================================
//================================================================================== 
//==================================================================================
//==================================================================================    
   //Получение данных из GUI и отправка оборудованию
   IR.AddListener(IR.EVENT_CHANNEL_SET, IR.GetDevice(DeviceName), function(name, value)
   {
      //Получение данных из GUI     
      switch(name)
      {
         case "Amati_Volume set": //В данную переменную передавать значение Value элемента (уровня)           
            if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=set_vol&param=',value.toString()]);
            break;
      }
  
      //навигация по прогрессу трека
      switch(name)
      {
         case "Amati_Seek": //В данную переменную передавать значение Value элемента (уровня)
            TrackTimeSeek = Math.floor(value * TimeTotal / 100);
            IR.Log("TrackTimeSeek = " + TrackTimeSeek);           
            if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=seekid&param=[' + SongID.toString() + ',' + TrackTimeSeek + ']']);
            break;       //["1",1058]
      }
      
      //Включение рандома
      switch(name)
      {
         case "Amati_Set random": //В данную переменную передавать значение Value элемента (уровня)
            if(value == 1)
               if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=set_random&param=true']);
            else if(value == 0)
               if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=set_random&param=false']);
            break;
      }

      //Mute
      switch(name)
      {
         case "Amati_Mute": //В данную переменную передавать значение Value элемента (уровня)
            if(value == 1)
               if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=set-mute&param=1']);
            else if(value == 0)
               if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=set-mute&param=0']);
            break;
      }
     
     //Управление Зонами
     switch(name)
      {
         case "Amati_ToggleZone": //В данную переменную передавать значение Value элемента (зоны)
            if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=zone&param="' + value + '"']);
            break;
      }

      
      //Работа с ftp
      switch(name)
      {
         case "Amati_Refresh FS": //Обновление списка FTP
            AutoRequestFTP();
            //IR.Log("Запрос на устройство отправлен");
            break;
            
         case "Amati_FS UpFolder": //На папку выше FTP
            if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=lsinfo&param=""""']);
            if (FilesystemCurrentFolder.length >> 0) FilesystemCurrentFolder.length = FilesystemCurrentFolder.length - 1; 
            AutoRequestFTP(); 
            break;
      }
            
      //Работа с Current Play List
      switch(name)
      {
         case "Amati_ClearCurrentPL": //Очистить Current Play List
            if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=clear&param="null"']);
            PlaylistArray.length = 0;
            
            AutoRequestPlaylist();
            break;
         
         case "Amati_SaveCurrentPL": //Сохранить Current Play List
            var CurrentName = IR.GetVariable("Global.CurrentListName");
            if (Amati_Online) DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=save&param="'+ CurrentName + '"']);
            AutoRequestPlaylist();
            break;

         case "Amati_Play PlayList": //Проиграть Play List
            
            break;
      }
            
   });

//==================================================================================    Amati_Play PlayList
//==================================================================================
//==================================================================================
//==================================================================================
//================================================================================== 
//==================================================================================
//==================================================================================    
   //Получение данных от оборудования и запись обратной связи
   IR.AddListener(IR.EVENT_RECEIVE_TEXT, DEVICE, function(inText)
   {
      IR.SetVariable("Drivers."+DeviceName+".Amati_Online", true);
      Amati_Online = true;
      IR.ClearInterval(DevOnlineSetTimeoutID);
      DevOnlineSetTimeoutID = IR.SetTimeout(DeviceOnlineTimeout, function() { 
                  IR.SetVariable("Drivers."+DeviceName+".Amati_Online", false)
                  Amati_Online = false
                  });

      if (inText == "[]")  {
         //IR.Log("CLEARING PL!!!");
         PlaylistArray.length = 0;
         PlaylistLength = 0;
         CheckPT();
         }
      else {
      var JSONObjectTemp = JSON.Parse(inText);
      var JSONObjectLength = JSONObjectTemp.length;
      //IR.Log("JSONObjectTemp=" + inText);
      
         
      if (JSONObjectTemp.state) 
      {
//==================================================================================
//==================================================================================
//==================================================================================
//========= ОбРАбОТКА ДАННЫХ ПЛЕЕРА ================================================
//================================================================================== 
//==================================================================================
//==================================================================================    
         //IR.Log("Данные песни");
         var JSONObject = JSONObjectTemp;

//==================================================================================      
         //Проверка и запись уровня громкости
         if((JSONObject.volume >= 0)&&(JSONObject.volume <= 100))
         { 
            //IR.Log("Volume = "+JSONObject.volume);
            IR.SetVariable("Drivers."+DeviceName+".Amati_Volume",parseFloat(JSONObject.volume));
         }
         
         //Mute
         var Mute = JSONObject.mute;
         //IR.Log("Mute = " + Mute);
//==================================================================================      
         //Проверка статуса включения
         if(JSONObject.state == "play")
         { 
            //IR.Log("State play = " + JSONObject.state);
            IR.SetVariable("Drivers."+DeviceName+".Amati_State",1);
         }
         else if((JSONObject.state == "stop")||(JSONObject.state == "pause"))
         { 
            //IR.Log("State stop or pause= " + JSONObject.state);
            IR.SetVariable("Drivers."+DeviceName+".Amati_State",0);
         }
//==================================================================================
         //Проверка проигранного времени
         TimeElapsed = Math.floor(JSONObject.elapsed);
         if (TimeElapsed >= 0)
         {
            var x = TimeConvert(TimeElapsed);
            IR.SetVariable("Drivers."+DeviceName+".Amati_Track time elapsed",x);
            //IR.Log("Проиграно = " + x);
         }   
//==================================================================================      
         //Проверка длительности трека
         TimeTotal = Math.floor(JSONObject.songdata.Time);
         if (TimeTotal >= 0)
         {
            var x = TimeConvert(TimeTotal);
            IR.SetVariable("Drivers."+DeviceName+".Amati_Track time total",x);
            //IR.Log("Общее время трека = " + x);
         }
//==================================================================================      
         //Вычисление прогресса трека
         TrackTimeProgress = Math.floor(100 * TimeElapsed / TimeTotal);
         IR.SetVariable("Drivers."+DeviceName+".Amati_Track time progress",TrackTimeProgress);
         //IR.Log("TrackTimeProgress = " + TrackTimeProgress + "%");
//==================================================================================
         //Получение номера текущего трека
         SongID = JSONObject.songid;
         IR.SetVariable("Drivers."+DeviceName+".Amati_Current song ID",SongID);
         
         NextSongID = JSONObject.nextsong;
      
         //Данные песни
         if(JSONObject.songdata.Genre)
            var TrackGenre = JSONObject.songdata.Genre;
         else
            var TrackGenre = "Неизвестный жанр"; 
         IR.SetVariable("Drivers."+DeviceName+".Amati_Track genre",TrackGenre);
      
         if(JSONObject.songdata.Album)
            var TrackAlbum = JSONObject.songdata.Album;
         else
            var TrackAlbum = "Неизвестный альбом";   
         IR.SetVariable("Drivers."+DeviceName+".Amati_Track album",TrackAlbum);
      
         var TrackFile = JSONObject.songdata.file;
         IR.SetVariable("Drivers."+DeviceName+".Amati_Track file",TrackFile);
      
         var TrackTitle = JSONObject.songdata.Title;
         IR.SetVariable("Drivers."+DeviceName+".Amati_Track title",TrackTitle);
      
         if(JSONObject.songdata.AlbumArtist)
         {
            var TrackAlbumArtist = JSONObject.songdata.AlbumArtist;
            IR.SetVariable("Global.ArtistName",TrackAlbumArtist);
         }   
         else 
         if (JSONObject.songdata.Artist)
         {
            var TrackAlbumArtist = JSONObject.songdata.Artist;
            IR.SetVariable("Global.ArtistName",TrackAlbumArtist);
         }   
         else
         {
            var TrackAlbumArtist = "Неизвестный артист";
            //var TrackTitlePart = TrackTitle.slice(0, TrackTitle.indexOf("-",0) - 1);
            //IR.Log(TrackTitlePart);
            //IR.SetVariable("Global.ArtistName",TrackTitlePart);
         }
         IR.SetVariable("Drivers."+DeviceName+".Amati_Track album artist",TrackAlbumArtist);
         
         //IR.Log("Global.ArtistName ======= " + IR.GetVariable("Global.ArtistName"));

//==================================================================================      
         var NextSongID = JSONObject.nextsongid;
         IR.SetVariable("Drivers."+DeviceName+".Amati_Next song ID",NextSongID);
        
         var Random = JSONObject.random;
         IR.SetVariable("Drivers."+DeviceName+".Amati_Random",Random);
      
         var Zones = JSONObject.zones;
         //IR.Log("ZONES: " + JSONObject.zones);
         IR.SetVariable("Drivers."+DeviceName+".Amati_Zone 1",Zones[0]);
         IR.SetVariable("Drivers."+DeviceName+".Amati_Zone 2",Zones[1]);
         IR.SetVariable("Drivers."+DeviceName+".Amati_Zone 3",Zones[2]);
         IR.SetVariable("Drivers."+DeviceName+".Amati_Zone 4",Zones[3]);

      };
       
      if (JSONObjectTemp[0].Id)
      {
//==================================================================================
//==================================================================================
//==================================================================================
//========= ОбРАбОТКА ДАННЫХ ПЛЕЙЛИСТА =============================================
//================================================================================== 
//==================================================================================
//==================================================================================     
         //IR.Log("Данные плейлиста");
         var JSONObject2 = JSONObjectTemp;
         
         PlaylistArray.length = 0;
         // Массив [[АРТИСТ][НАЗВАНИЕ ПЕСНИ][АЛЬБОМ][ДЛИТЕЛЬНОСТЬ ПЕСНИ][ПОЗИЦИЯ В СПИСКЕ][ID]]
         var PlaylistArtist, PlaylistTitle, PlaylistAlbum, PlaylistPos, PlaylistID;
      
         //Элементы плейлиста
         var Playlist = JSONObject2;
         PlaylistLength = JSONObject2.length;
         IR.SetVariable("Drivers."+DeviceName+".Amati_Playlist length",PlaylistLength);
         //IR.Log("PlaylistLength = " + PlaylistLength);

         //Данные первого вхождения
         for(i=0;i<PlaylistLength;i++)
         {
            if (JSONObject2[i].Artist) 
               PlaylistArtist = JSONObject2[i].Artist;   
            else
               PlaylistArtist = "Неизвестный артист";
            PlaylistArray[6*i] = PlaylistArtist; 
            //IR.Log("PlaylistArtist = " + PlaylistArrayElement[0]);
            
            if (JSONObject2[i].Title) 
               PlaylistTitle = JSONObject2[i].Title   
            else
               if (JSONObject2[i].file) {
                  PlaylistTitle = JSONObject2[i].file;
                  
                  PlaylistArray[6*i] = PlaylistTitle.slice(PlaylistTitle.lastIndexOf("/")+1);
                  //IR.Log("PlaylistTitle.indexOf("/",PlaylistTitle.length)"+PlaylistTitle.indexOf("/",0));
                  PlaylistTitle = PlaylistTitle.slice(0,PlaylistTitle.length-PlaylistArray[6*i].length);
                  }
               else
                  PlaylistTitle = "Неизвестная композиция";
            
            PlaylistArray[6*i+1] = PlaylistTitle;
            //IR.Log("PlaylistTitle = " + PlaylistArrayElement[1]);
         
            if (JSONObject2[i].Album) 
               PlaylistAlbum = JSONObject2[i].Album;   
            else
               PlaylistAlbum = "Неизвестный альбом";
            PlaylistArray[6*i+2] = PlaylistAlbum;
            //IR.Log("Album = " + PlaylistArrayElement[2]);
         
            if (JSONObject2[i].Time) 
               PlaylistTime = JSONObject2[i].Time;   
            else
               PlaylistTime = "0:00:00";
            PlaylistArray[6*i+3] = PlaylistTime;
            //IR.Log("PlaylistTime = " + PlaylistArrayElement[3]);
         
            PlaylistPos = JSONObject2[i].Pos;
            PlaylistArray[6*i+4] = PlaylistPos; 
            PlaylistID = JSONObject2[i].Id;
            PlaylistArray[6*i+5] = PlaylistID;
            //IR.Log("Pos:Id = " + PlaylistArray[6*i+4] + ":" + PlaylistArray[6*i+5]);
         
         };
         
         CheckPT();
      };

//==================================================================================
//========= ОбРАбОТКА СПИСКА ПЛЕЙЛИСТОВ ============================================
//================================================================================== 
      if (JSONObjectTemp[0].playlist)
      {
         ListPlaylistArray.length = 0;
         // Массив [[АРТИСТ][НАЗВАНИЕ ПЕСНИ][АЛЬБОМ][ДЛИТЕЛЬНОСТЬ ПЕСНИ][ПОЗИЦИЯ В СПИСКЕ][ID]]
         var PlaylistName, PlaylistLastModifed;
      
         //Элементы плейлиста
         var ListPlaylist = JSONObjectTemp;
         ListPlaylistLength = ListPlaylist.length;
         IR.SetVariable("Drivers."+DeviceName+".Amati_List of Playlist length",ListPlaylistLength);
         //IR.Log("PlaylistLength = " + ListPlaylistLength);

         //Данные первого вхождения
         for(i=0;i<ListPlaylistLength;i++)
         {
            if (ListPlaylist[i].playlist) {
                PlaylistName = ListPlaylist[i].playlist;   
                ListPlaylistArray[2*i] = PlaylistName;
                };
                 
            PlaylistLastModifed = JSON.Stringify(ListPlaylist[i]);
            if (PlaylistLastModifed.indexOf("Last-Modified",0) >> 0) {
                var IndexOfLM = PlaylistLastModifed.indexOf("Last-Modified",0);
                PlaylistLastModifed = PlaylistLastModifed.slice(IndexOfLM+16,IndexOfLM+26) + " " + PlaylistLastModifed.slice(IndexOfLM+27,IndexOfLM+35);   
                ListPlaylistArray[2*i+1] = PlaylistLastModifed; 
            //IR.Log("List of Playlists = " + PlaylistLastModifed);
                }
         
         };
         
         DrawLPL();
      };

//==================================================================================
//==================================================================================

      
      if (((JSONObjectTemp[0].file) || (JSONObjectTemp[0].directory)) && !(JSONObjectTemp[0].Id))     {
//==================================================================================
//==================================================================================
//==================================================================================
//========= ОбРАбОТКА ДАННЫХ ФАЙЛОВОЙ СИСТЕМЫ ======================================
//================================================================================== 
//==================================================================================
//==================================================================================        
         IR.Log("Данные файловой системы");
         var JSONObject3 = JSONObjectTemp;
         
         FilesystemArray.length = 0;
         //              0               1                 2           3     4 
         // Массив [[ИМЯ ФАЙЛА][ДЛИТЕЛЬНОСТЬ ПЕСНИ][ПОЗИЦИЯ В СПИСКЕ][ID][Folder]]
         var FilesystemArtist, FilesystemTitle, FilesystemAlbum, FilesystemTime;
      
         //Элементы плейлиста
         //Данные первого вхождения 
         FilesystemLength = 0;
         for(i=0;i<JSONObject3.length;i++)
         {
         if (JSONObject3[i].directory) {
            FilesystemArray[6*i] = JSONObject3[i].directory;   
            FilesystemArray[6*i+4] = true;
            FilesystemLength++ } 
            else {   
            if (JSONObject3[i].file) {
               FilesystemArray[6*i] = JSONObject3[i].file;   
               FilesystemArray[6*i+4] = false;
               FilesystemLength++ };
            
            if (JSONObject3[i].Time) 
               PlaylistTime = JSONObject3[i].Time;   
            else
               PlaylistTime = "0:00:00";
            PlaylistArray[6*i+1] = PlaylistTime;

            //PlaylistPos = JSONObject2[i].Pos;
            //PlaylistArray[6*i+2] = PlaylistPos; 
            //PlaylistID = JSONObject2[i].Id;
            //PlaylistArray[6*i+3] = PlaylistID;

            //IR.Log("Элемент ФС ["+i+"] = " + FilesystemArray[i]);
            };
         
         
         
         };
          
         //IR.Log("FilesystemLength = " + FilesystemLength);
         IR.SetVariable("Drivers."+DeviceName+".Amati_Filesystem length",FilesystemLength);


         DrawFS();   

      };  //========= КОНЕЦ ОбРАбОТКА ДАННЫХ ФАЙЛОВОЙ СИСТЕМЫ =======================
   
      };
   }); //IR.AddListener(IR.EVENT_RECEIVE_TEXT, DEVICE, function(inText)
}

